#
# Testing CAD
# License: GNU General Public License 3
# Uray M. János
# 2019-2020
#

load("stopwatch.sage");
load("logic.sage");
load("cad.sage");

watch = Stopwatch();

var("x,y,z");
var("a,b,c,d,e");
var("p,q,r,u,v");

#input = [(x-2)^2 + (y-2)^2 - 1, x*y - 1];
#input = [(x-2)^2 + (y-2)^2 + (z-2)^2 - 1, x*y*z - 1];
#input = x^2 + y^2 - 2;
#input = x^2 + y^2 + z^2 - 2;
#input = [x^2 + y^2 - 1, x^3 - y^2];
#input = [x^2 + y^2 + z^2 - 1, z^3 + x*z + y]; # NOTE don't print the cells, too many

#input = logic_and(x^2 + y^2 + z^2 <= 4, x*y*z == 1);
#input = logic_and((x-1)^2 + (y-1)^2 + (z-1)^2 <= 1, x*y*z == 1);
#input = logic_and(x^2 + y^2 < 1, x^3 == y^2);
#input = logic_or(logic_and(x^2 + y^2 <= 1, x^2 == y), logic_and((x-1)^2 + (y-1)^2 <= 1, (x-2)^2 + (y-2)^2 <= 1));
#input = logic_or(logic_and(x^2 + y^2 <= 1, x^2 == y), (x-1)^2 + (y-1)^2 <= 1);
#input = logic_and(x^2 + y^2 <= 1, x^2 == y);
#input = logic_exists(x, logic_forall(y, x^2 - y^2 < z));
#input = logic_exists(y, logic_forall(z, logic_or(x^2 + y^2 + z^2 < 1, x > 0)));
#input = logic_forall(y, logic_or(y > x^2, y <= 3 - x^2));
#input = logic_forall(y, x^2 + y^2 < 1);
#input = logic_exists(y, logic_and(x^2 + y^2 == 3, x + y < 0)); # NOTE new polynomials in output
#input = logic_and(x^2 + y^2 == 3, x + y < 0); # NOTE new polynomials in output
#input = logic_and(x^2 <= 2, x > -1);
#input = x^2 + y^2 + z^2 <= 2;
#input = logic_and(x*z > 0, x*z + y <= 0);
#input = x*y >= 2;
#input = logic_exists(z, logic_and((x^2 + y^2 + z^2 + x)^2 + 3*(y + z - 2*x - 1)^2 - 14*x*(x+1) - 13*y*z + 7 < 0, x + y + 2*z > 0)); # TODO new polynomials in output
#input = logic_and(x^2 + y^2 + z^2 == 1, z^3 + x*z + y == 0); # TODO new polynomials in output
#input = x^6 + y^6 < y;

#input = x/y + y/x > 2;
#input = x*sqrt(y) + (y-x) > 0;
#input = max_symbolic(x, y)^3 >= 1;
#input = max_symbolic(x, y)^2 >= 1;
#input = sqrt(x) >= x-1;
input = sqrt(x) + sqrt(y) >= 1;
#input = x^(1/3) + y^(1/3) >= 1;
#input = sqrt(x) + y^(1/3) >= 1;
#input = sqrt(x) + sqrt(x+1) >= x;
#input = x^(1/3) + (x+1)^(1/3) >= x;
#input = sqrt(1 + sqrt(x)) >= x;
#input = (1 + x^(1/3))^(1/3) >= x;

#input = logic_exists(x, a*x^2 + b*x + c == 0);
#input = logic_forall(x, x^4 + a*x^2 + b*x + c >= 0);
#input = logic_forall(x, x^4 + a*x^3 + b*x^2 + c*x + d > 0);
#input = logic_exists(z, x == sqrt(1 - y^2 - z^2));
#input = logic_forall(x, logic_exists(y, logic_and(x^2 + x*y + b > 0, x + a*y^2 + b <= 0)));

#input = logic_exists(b, logic_exists(u, logic_exists(v, logic_and(
	#logic_or(r^2 - 24*r + 16 < 0, logic_and(r > 1, r^2 - 24*r + 16 >= 0)),
	#-1 < u, u < v, v < 1,
	#u^4 + r*u^3 - a*u^2 - b*u - (1 - a) == r - b,
	#v^4 + r*v^3 - a*v^2 - b*v - (1 - a) == -r + b,
	#4*u^3 + 3*r*u^2 - 2*a*u - b == 0,
	#4*v^3 + 3*r*v^2 - 2*a*v - b == 0,
	#r - b > 0
#))));
#input = input.subs(r==2);

## NOTE too slow
#input = logic_implies(
	#logic_and(a > 0, b > 0, c > 0, a + b + c == 1),
	#1/a + 1/b + 1/c >= 25 / (1 + 48*a*b*c)
#);

print "in:", input;
output = convert_formula_to_poly(logic(input));
print "pre:", output;

t = time.time();
#output = cylindrical_algebraic_decomposition(input, algorithm="qepcad", watch=watch);
#output = cylindrical_algebraic_decomposition(input, output="poly", watch=watch, proj="mccallum");
output = cylindrical_algebraic_decomposition(input, watch=watch, proj="mccallum");
t = time.time() - t;

if isinstance(output, CADCell):
	print "out:";
	n = 0;
	for cell in output.cells():
		n += 1;
		print cell.dimension(), cell.sample(), cell.formula();
	print n, "cells";
else:
	print "out:", output;
print t, "s";
watch.print_all();

